Index: trunk/SophyaLib/HiStats/hisprof.h
===================================================================
--- trunk/SophyaLib/HiStats/hisprof.h	(revision 2478)
+++ trunk/SophyaLib/HiStats/hisprof.h	(revision 2479)
@@ -88,5 +88,5 @@
   \brief Persistance management */
 inline PInPersist& operator >> (PInPersist& is, HProf & obj)
-{ ObjFileIO<HProf> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<HProf> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 // Classe pour la gestion de persistance
 // ObjFileIO<HProf>
Index: trunk/SophyaLib/HiStats/histos.h
===================================================================
--- trunk/SophyaLib/HiStats/histos.h	(revision 2478)
+++ trunk/SophyaLib/HiStats/histos.h	(revision 2479)
@@ -1,5 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
 //
-// $Id: histos.h,v 1.16 2003-02-11 15:31:00 cmv Exp $
+// $Id: histos.h,v 1.17 2003-12-06 23:58:17 ansari Exp $
 //
 
@@ -174,5 +174,5 @@
   \brief Persistance management */
 inline PInPersist& operator >> (PInPersist& is, Histo & obj)
-{ ObjFileIO<Histo> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<Histo> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 // Classe pour la gestion de persistance
Index: trunk/SophyaLib/HiStats/histos2.h
===================================================================
--- trunk/SophyaLib/HiStats/histos2.h	(revision 2478)
+++ trunk/SophyaLib/HiStats/histos2.h	(revision 2479)
@@ -253,5 +253,5 @@
   \brief Persistance management */
 inline PInPersist& operator >> (PInPersist& is, Histo2D & obj)
-{ ObjFileIO<Histo2D> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<Histo2D> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 // Classe pour la gestion de persistance
Index: trunk/SophyaLib/HiStats/ntuple.h
===================================================================
--- trunk/SophyaLib/HiStats/ntuple.h	(revision 2478)
+++ trunk/SophyaLib/HiStats/ntuple.h	(revision 2479)
@@ -106,5 +106,5 @@
 /*! Reads the object from the PInPersist stream \b is */
 inline PInPersist& operator >> (PInPersist& is, NTuple & obj)
-{ ObjFileIO<NTuple> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<NTuple> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 // Classe pour la gestion de persistance
Index: trunk/SophyaLib/HiStats/xntuple.h
===================================================================
--- trunk/SophyaLib/HiStats/xntuple.h	(revision 2478)
+++ trunk/SophyaLib/HiStats/xntuple.h	(revision 2479)
@@ -168,5 +168,5 @@
 /*! Reads the object from the PInPersist stream \b is */
 inline PInPersist& operator >> (PInPersist& is, XNTuple & obj)
-{ ObjFileIO<XNTuple> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<XNTuple> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 // Classe pour la gestion de persistance
Index: trunk/SophyaLib/NTools/generaldata.h
===================================================================
--- trunk/SophyaLib/NTools/generaldata.h	(revision 2478)
+++ trunk/SophyaLib/NTools/generaldata.h	(revision 2479)
@@ -188,5 +188,5 @@
 //! For persistance management
 inline PInPersist& operator >> (PInPersist& is, GeneralFitData & obj)
-{ ObjFileIO<GeneralFitData> fio(&obj);  fio.Read(is);  return(is); }
+{ ObjFileIO<GeneralFitData> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 // Classe pour la gestion de persistance
Index: trunk/SophyaLib/SkyMap/fiolocalmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/fiolocalmap.h	(revision 2478)
+++ trunk/SophyaLib/SkyMap/fiolocalmap.h	(revision 2479)
@@ -52,5 +52,5 @@
 template <class T>
 inline PInPersist& operator >> (PInPersist& is, LocalMap<T> & obj)
-{ FIO_LocalMap<T> fio(&obj);  fio.Read(is);  return(is); }
+{ FIO_LocalMap<T> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 
Index: trunk/SophyaLib/SkyMap/fiospherehealpix.h
===================================================================
--- trunk/SophyaLib/SkyMap/fiospherehealpix.h	(revision 2478)
+++ trunk/SophyaLib/SkyMap/fiospherehealpix.h	(revision 2479)
@@ -51,5 +51,5 @@
 template <class T>
 inline PInPersist& operator >> (PInPersist& is, SphereHEALPix<T> & obj)
-{ FIO_SphereHEALPix<T> fio(&obj);  fio.Read(is);  return(is); }
+{ FIO_SphereHEALPix<T> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 } // Fin du namespace
Index: trunk/SophyaLib/SkyMap/fiospherethetaphi.h
===================================================================
--- trunk/SophyaLib/SkyMap/fiospherethetaphi.h	(revision 2478)
+++ trunk/SophyaLib/SkyMap/fiospherethetaphi.h	(revision 2479)
@@ -52,5 +52,5 @@
 template <class T>
 inline PInPersist& operator >> (PInPersist& is, SphereThetaPhi<T> & obj)
-{ FIO_SphereThetaPhi<T> fio(&obj);  fio.Read(is);  return(is); }
+{ FIO_SphereThetaPhi<T> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
 
 
Index: trunk/SophyaLib/SkyT/gaussfilt.h
===================================================================
--- trunk/SophyaLib/SkyT/gaussfilt.h	(revision 2478)
+++ trunk/SophyaLib/SkyT/gaussfilt.h	(revision 2479)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: gaussfilt.h,v 1.5 2000-04-06 17:09:39 ansari Exp $
+//      $Id: gaussfilt.h,v 1.6 2003-12-06 23:59:21 ansari Exp $
 //
 // Description:
@@ -67,6 +67,6 @@
     { ObjFileIO<GaussianFilter> fio(&obj); fio.Write(os); return(os);}
   
-  inline PInPersist& operator >> (PInPersist& os, GaussianFilter & obj)
-    { ObjFileIO<GaussianFilter> fio(&obj); fio.Read(os); return(os);}
+  inline PInPersist& operator >> (PInPersist& is, GaussianFilter & obj)
+    { ObjFileIO<GaussianFilter> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is);}
 
 }  // End of namespace 
Index: trunk/SophyaLib/SkyT/specrespvector.h
===================================================================
--- trunk/SophyaLib/SkyT/specrespvector.h	(revision 2478)
+++ trunk/SophyaLib/SkyT/specrespvector.h	(revision 2479)
@@ -2,5 +2,5 @@
 //--------------------------------------------------------------------------
 // File and Version Information:
-//      $Id: specrespvector.h,v 1.6 2003-02-11 15:31:07 cmv Exp $
+//      $Id: specrespvector.h,v 1.7 2003-12-06 23:59:21 ansari Exp $
 //
 // Description:
@@ -70,6 +70,6 @@
     { ObjFileIO<SpecRespVec> fio(&obj); fio.Write(os); return(os);}
   
-  inline PInPersist& operator >> (PInPersist& os, SpecRespVec & obj)
-    { ObjFileIO<SpecRespVec> fio(&obj); fio.Read(os); return(os);}
+  inline PInPersist& operator >> (PInPersist& is, SpecRespVec & obj)
+    { ObjFileIO<SpecRespVec> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is);}
 
 }  // End of namespace 